
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Ai_chat_threadsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const ai_chat_threads = await db.ai_chat_threads.create(
            {
                id: data.id || undefined,
        
        thread_title: data.thread_title
        ||
        null
            ,
            
        last_message_at: data.last_message_at
        ||
        null
            ,
            
        pinned: data.pinned
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await ai_chat_threads.setUser( data.user || null, {
            transaction,
        });
        

        

        

        return ai_chat_threads;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const ai_chat_threadsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                thread_title: item.thread_title
            ||
            null
            ,
            
                last_message_at: item.last_message_at
            ||
            null
            ,
            
                pinned: item.pinned
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const ai_chat_threads = await db.ai_chat_threads.bulkCreate(ai_chat_threadsData, { transaction });

        // For each item created, replace relation files
        

        return ai_chat_threads;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const ai_chat_threads = await db.ai_chat_threads.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.thread_title !== undefined) updatePayload.thread_title = data.thread_title;
        
        
        if (data.last_message_at !== undefined) updatePayload.last_message_at = data.last_message_at;
        
        
        if (data.pinned !== undefined) updatePayload.pinned = data.pinned;
        
        
        updatePayload.updatedById = currentUser.id;

        await ai_chat_threads.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await ai_chat_threads.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        

        
        

        

        return ai_chat_threads;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const ai_chat_threads = await db.ai_chat_threads.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of ai_chat_threads) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of ai_chat_threads) {
                await record.destroy({transaction});
            }
        });


        return ai_chat_threads;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const ai_chat_threads = await db.ai_chat_threads.findByPk(id, options);

        await ai_chat_threads.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await ai_chat_threads.destroy({
            transaction
        });

        return ai_chat_threads;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const ai_chat_threads = await db.ai_chat_threads.findOne(
            { where },
            { transaction },
        );

        if (!ai_chat_threads) {
            return ai_chat_threads;
        }

        const output = ai_chat_threads.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.ai_chat_messages_thread = await ai_chat_threads.getAi_chat_messages_thread({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await ai_chat_threads.getUser({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.thread_title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'ai_chat_threads',
                        'thread_title',
                        filter.thread_title,
                    ),
                };
            }
            

            
            

            
            if (filter.last_message_atRange) {
                const [start, end] = filter.last_message_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    last_message_at: {
                    ...where.last_message_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    last_message_at: {
                    ...where.last_message_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.pinned) {
                where = {
                    ...where,
                pinned: filter.pinned,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.ai_chat_threads.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'ai_chat_threads',
                        'thread_title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.ai_chat_threads.findAll({
            attributes: [ 'id', 'thread_title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['thread_title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.thread_title,
        }));
    }

    
};

